About
Extend videos with xAI's Grok Imagine video model.
1. Calling the API
Setup your API Key
To begin using Infron, you first need to create an account and generate your API Key.
Once you have your API key, set it as an environment variable in your runtime environment. This allows your applications to securely access Infron’s API.
export INFRON_KEY="YOUR_API_KEY"
Submit a request
For long-running requests, you can poll for results.
curl https://media.onerouter.pro/v1/videos/generations \
-H "Authorization: Bearer YOUR_API_KEY" \
-H "Content-Type: application/json" \
-d @- <<'EOF'
{
"model": "x-ai/grok-imagine-video/video-extend",
"prompt": "Clouds timelapse there are mountains behind.",
"video_urls": ["https://storage.googleapis.com/infron_gcs/quick-upload/2026/06/22/20260622-185901-7acfc5c6-mgw2j46dDpMU8kEKzwiPx_9TItkrX6_vyHGMKUfpugW_output.mp4"],
"duration": 10,
"n": 1
}
EOF
Response with queue task id
The response will look like this:
{
"code": 200,
"message": "success",
"data": {
"task_id": "bdeb384008214c42b3dc79ed7715955b",
"object": "video",
"model": "x-ai/grok-imagine-video/video-extend",
"status": "created",
"urls": {
"query": "https://media.onerouter.pro/v1/videos/tasks/bdeb384008214c42b3dc79ed7715955b"
},
"created_at": "2026-06-22 12:43:34.96"
}
}
Fetch request status
You can fetch the status of a request to check if it is completed or still in progress.
curl https://media.onerouter.pro/v1/videos/tasks/{task_id} \
-H "Authorization: Bearer YOUR_API_KEY" \
-H "Content-Type: application/json"
# For example
curl https://media.onerouter.pro/v1/videos/tasks/bdeb384008214c42b3dc79ed7715955b \
-H "Authorization: Bearer YOUR_API_KEY" \
-H "Content-Type: application/json"
Response with queue task status query
{
"code": 200,
"message": "success",
"data": {
"task_id": "bdeb384008214c42b3dc79ed7715955b",
"object": "video",
"model": "x-ai/grok-imagine-video/video-extend",
"status": "in_progress",
"fail_reason": "",
"submit_time": 1782132215,
"start_time": 1782132215,
"finish_time": 0,
"outputs": [],
"created_at": "2026-06-22 12:43:35"
}
}
Possible statuses:
- created
- in_progress
- processing
- completed
- failed
created -> in_progress → processing → completed | failed
Poll every 1-2 seconds until status is "completed" or "failed"
Get the result (when status is "completed")
Once the request is completed, you can fetch the result. See the Output Schema for the expected result format.
{
"code": 200,
"message": "success",
"data": {
"task_id": "bdeb384008214c42b3dc79ed7715955b",
"object": "video",
"model": "x-ai/grok-imagine-video/video-extend",
"status": "completed",
"fail_reason": "",
"submit_time": 1782132215,
"start_time": 1782132215,
"finish_time": 1782132257,
"outputs": [
"https://storage.googleapis.com/infron_gcs/video%2Fvideo_v2%2Foutput%2Foutput_f9f263f9-c07d-4b4c-be82-7f74f3189295.mp4"
],
"usage": {
"completion_tokens": 0,
"duration": 6,
"generate_audio": false,
"output_count": 1,
"prompt_tokens": 1,
"request_num": 1,
"resolution": "720p",
"tokens": 1,
"total_tokens": 1,
"video_duration": 6
},
"cost": {
"total_cost": 0.35,
"cost_details": {
"prompt_cost": 0,
"completion_cost": 0,
"image_cost": 0,
"video_cost": 0.35,
"audio_cost": 0,
"native_web_search_cost": 0,
"plugin_web_search_cost": 0,
"tools_cost": 0,
"prompt_cache_read_cost": 0,
"prompt_cache_write_cost": 0,
"prompt_cache_write_5_min": 0,
"prompt_cache_write_1_h": 0,
"reasoning_cost": 0,
"discount_rate": 1,
"is_byok": false,
"byok_cost": 0
}
},
"created_at": "2026-06-22 12:43:35"
}
}
2. Schema
Input
| Parameter | Type | Required | Default | Range | Description |
|---|---|---|---|---|---|
| model | string | Yes | -- | Explore all models | Model name. |
| prompt | string | Yes | -- | -- | Text prompt for generation; Positive text prompt. |
| video_urls | array | Yes | -- | [1] | Video URLs. |
| duration | integer | No | -- | [2,10] | Duration of the video in seconds, between 2 and 10. |
| n | integer | No | 1 | [1] | Number of videos to generate. |
Example request
curl https://media.onerouter.pro/v1/videos/generations \
-H "Authorization: Bearer YOUR_API_KEY" \
-H "Content-Type: application/json" \
-d @- <<'EOF'
{
"model": "x-ai/grok-imagine-video/video-extend",
"prompt": "Clouds timelapse there are mountains behind.",
"video_urls": ["https://storage.googleapis.com/infron_gcs/quick-upload/2026/06/22/20260622-185901-7acfc5c6-mgw2j46dDpMU8kEKzwiPx_9TItkrX6_vyHGMKUfpugW_output.mp4"],
"duration": 10,
"n": 1
}
EOF
Output
| Parameter | Type | Range | Description |
|---|---|---|---|
| code | integer | -- | Status code of the request. |
| message | string | -- | Status message of the request. |
| data | object | -- | Data of the video task. |
| data.task_id | string | -- | ID of the video task. |
| data.object | string | -- | Object type of the video task. |
| data.model | string | -- | Model name of the video task. |
| data.status | string | created, in_progress, processing, completed, failed | Status of the video task. |
| data.fail_reason | string | -- | Fail reason of the video task. |
| data.submit_time | integer | -- | Timestamp of the video task submission. |
| data.start_time | integer | -- | Timestamp of the video task start. |
| data.finish_time | integer | -- | Timestamp of the video task finish. |
| data.outputs | array | -- | Outputs of the video task. |
| data.created_at | string | -- | Timestamp of the video task creation. |
Example output
{
"code": 200,
"message": "success",
"data": {
"task_id": "bdeb384008214c42b3dc79ed7715955b",
"object": "video",
"model": "x-ai/grok-imagine-video/video-extend",
"status": "completed",
"fail_reason": "",
"submit_time": 1782132215,
"start_time": 1782132215,
"finish_time": 1782132257,
"outputs": [
"https://storage.googleapis.com/infron_gcs/video%2Fvideo_v2%2Foutput%2Foutput_f9f263f9-c07d-4b4c-be82-7f74f3189295.mp4"
],
"usage": {
"completion_tokens": 0,
"duration": 6,
"generate_audio": false,
"output_count": 1,
"prompt_tokens": 1,
"request_num": 1,
"resolution": "720p",
"tokens": 1,
"total_tokens": 1,
"video_duration": 6
},
"cost": {
"total_cost": 0.35,
"cost_details": {
"prompt_cost": 0,
"completion_cost": 0,
"image_cost": 0,
"video_cost": 0.35,
"audio_cost": 0,
"native_web_search_cost": 0,
"plugin_web_search_cost": 0,
"tools_cost": 0,
"prompt_cache_read_cost": 0,
"prompt_cache_write_cost": 0,
"prompt_cache_write_5_min": 0,
"prompt_cache_write_1_h": 0,
"reasoning_cost": 0,
"discount_rate": 1,
"is_byok": false,
"byok_cost": 0
}
},
"created_at": "2026-06-22 12:43:35"
}
}
3. Detailed Pricing
| Pricing Type | Unit | Price |
|---|---|---|
| Input text | - | - |
| Input image | 1 image | $0.002 |
| Input video | 1 second | $0.010 |
| Output video | 1 second | $0.050–$0.070 |
| Resolution | Estimated Price |
|---|---|
| 480p | $0.050 / second |
| 720p | $0.070 / second |